library ieee;
use ieee.std_logic_1164.all;

entity adder is

port ( A,B: in std_logic_vector(31 downto 0);
	R: out std_logic_vector(31 downto 0)
	);
end adder;

architecture beh of adder is
 begin
 
  process(A,B)
   variable C: std_logic_vector(32 downto 0);
   variable Ain,Bin: std_logic;
   begin
    C(0) := '0';
    for i in 0 to 31 loop
     Ain := not A(i);
     Bin := not B(i);
     R(i) <= (Ain and Bin and C(i)) 
            or (Ain and B(i) and not C(i))
            or (A(i) and Bin and not C(i))
            or (A(i) and B(i) and C(i) );
      C(i+1) := (A(i) and B(i))
      		or (A(i) and C(i))
      		or (B(i) and C(i));
    end loop;
    end process;
   end beh;   		      	
