library ieee;
use ieee.std_logic_1164.all;

entity adder is
  generic (d : integer range 0 to 32 := 32);
  
  port (A, B : in std_logic_vector( d-1 downto 0);
        R: out std_logic_vector( d-1 downto 0);
        co: out std_logic);
end adder;

architecture schematic of adder is
 component adder1 is
  port( a,b,ci: in std_logic;
        co,r: out std_logic);
end component;

signal C : std_logic_vector(d-1 downto 0);

begin
  GA: for i in 0 to d-1 generate
  
    GA0: if i=0 generate
     ad0: adder1 port map (A(0), B(0), '0', C(0),R(0));
    end generate GA0;
    
    GAI: if i>0 generate
    adi: adder1 port map (A(i),B(i),C(i-1),C(i), R(i));
  end generate GAI;
  
end generate GA;

co<= C(d-1);

end schematic;

 
           