library ieee;
use ieee.std_logic_1164.all;

entity control_unit is
port ( clk, start : in std_logic;
       mm,mu: in std_logic;
       sela,selb,rega,regb,regm,fine: out std_logic);
end control_unit;


architecture beh of control_unit is
 signal cstato : std_logic_vector(2 downto 0);
 signal tfine: std_logic;
begin

 process(cstato)
  begin
    case cstato is 
      when "000" =>  -- idle 
      			sela<= '0';
      			selb<= '0';
      			rega<= '0';
      			regb<= '0';
      			regm<= '0';
      			tfine <='0';
      when "001" =>   -- memorizza a e b
      			sela<= '0';
      			selb<= '0';
      			rega<= '1';
      			regb<= '1';
      			regm<= '0';
      			tfine <='0';
      when "010" =>   -- confronto
      			sela<= '0';
      			selb<= '0';
      			rega<= '0';
      			regb<= '0';
      			regm<= '0';
      			tfine <='0';			
      when "011" =>   -- aggiorna a 
      			sela<= '1';
      			selb<= '0';
      			rega<= '1';
      			regb<= '0';
      			regm<= '0';
      			tfine <='0';
      when "100" =>   -- aggiorna b
      			sela<= '0';
      			selb<= '1';
      			rega<= '0';
      			regb<= '1';
      			regm<= '0';
      			tfine <='0';
      when "101" =>   -- fine
      			sela<= '0';
      			selb<= '0';
      			rega<= '0';
      			regb<= '0';
      			regm<= '1';
      			tfine <='1';
      when others => 	sela<= '0';
      			selb<= '0';
      			rega<= '0';
      			regb<= '0';
      			regm<= '0';
      			tfine <='0';
     end case;
     
   end process;		
      			
   process(clk,start,mu,mm)
     begin
     
      if clk'event and clk='0' then
      fine <=tfine;
       if start = '1' then cstato <= "001" after 1 ns; -- -> memorizza   			
       else case cstato is
             when "001" => cstato <= "010" after 1 ns; -- memorizza -> confronta			
      	     when "010" => if mu = '1' then cstato <= "101" after 1 ns;	--confronta -> fine
      	     		   else if mm ='1' then cstato <= "011" after 1 ns; --confronta -> aggiorna a
      	    		        	   else  cstato <= "100" after 1 ns; --confronta -> aggiorna b
      	    		        end if;
      	    		   end if;
      	    when "011" => cstato <= "010" after 1 ns; --aggiorna a -> confronta
      	    when "100" => cstato <= "010" after 1 ns; --aggiorna b -> confronta
      	    when "101" => cstato <= "000" after 1 ns; --fine -> idle
      	    when others => cstato <= "000" after 1 ns; -- -> idle
      	   end case;
      	end if;
      end if;
   end process;
   
  end beh;    	     		        
      	     	



