library ieee;
use ieee.std_logic_1164.all;

entity cu is
       port (ma,mb : in integer;
             nw,clk: in std_logic;
             ready: out std_logic;
             wa,wb,wc: out std_logic;
             sela,selb : out std_logic;
             stato : out integer
             );
end cu;

architecture beh of cu is
    signal st : integer := 0;
    begin
        
        process(nw,clk)
            begin
                if nw = '1' then
                   st <= 1; -- idle 2 write a b
                  elsif clk'event and clk='0' then
                  case st is
                  when 1 => st <= 2 after 2 ns;  -- write 2 confr 
                  when 2 => if ma = mb then st <= 5 after 2 ns;
                           elsif ma < mb then st <= 3 after 2 ns;
                           else st <= 4 after 2 ns;
                        end if;
                  when 3 => st <= 2 after 2 ns;
                  when 4 => st <= 2 after 2 ns;
                  when 5 => st <= 0 after 2 ns;
                  when others => st <= 0 after 2 ns;
              end case;            
         end if;
     end process;
     
     process (st)
         begin
             case st is 
               when 0 => wa <= '0';
                         wb <= '0';
                         wc <= '0';
                         sela <= '0';
                         selb <= '0';
                         ready <= '1';
               when 1 => wa <= '1';
                         wb <= '1';
                         wc <= '0';
                         sela <= '0';
                         selb <= '0';
                         ready <= '0';
               when 2 => wa <= '0';
                         wb <= '0';
                         wc <= '0';
                         sela <= '1';
                         selb <= '1';
                         ready <= '0';
               when 3 => wa <= '1';
                         wb <= '0';
                         wc <= '0';
                         sela <= '1';
                         selb <= '1';
                         ready <= '0'; 
               when 4 => wa <= '0';
                         wb <= '1';
                         wc <= '0';
                         sela <= '1';
                         selb <= '1';
                         ready <= '0';
               when 5 => wa <= '0';
                         wb <= '0';
                         wc <= '1';
                         sela <= '1';
                         selb <= '1';
                         ready <= '0';
              when others => null;
           end case;
           
     end process;                         
     stato <= st;    
     end beh;
     
               
