library ieee;
use ieee.std_logic_1164.all;

entity mcm is
    port ( a,b : in integer;
           nw : in std_logic;
           clk : in std_logic;
           ris: out integer;
           ready : out std_logic
           );
end mcm;

architecture schem of mcm is
    
    
    component registro is
        port (d: in integer;
               clk: in std_logic;
               q: out integer);
   end component;
   

   component cu is
       port (ma,mb : in integer;
             nw,clk: in std_logic;
             ready: out std_logic;
             wa,wb,wc: out std_logic;
             sela,selb : out std_logic;
             stato : out integer);
end component;

signal ma,mb, mcma, mcmb, sa, sb, stato: integer;
signal wa,wb,wc, sela,selb, clka,clkb,clkc: std_logic;

begin
    
   ma <= a when sela = '0' else
         sa;
         
   mb <= b when selb = '0' else
         sb;
          
     
    clka <= clk and wa;
    rmcma: registro port map( ma, clka, mcma);
    clkb <= clk and wb;
    rmcmb: registro port map( mb, clkb, mcmb);
    clkc <= clk and wc;
    rmcmc: registro port map( mcma, clkc, ris);
    
    sa <= mcma + a after 1 ns;
    sb <= mcmb + b after 1 ns;
    
    mcu: cu port map (mcma,mcmb,
             nw,clk, 
             ready, 
             wa,wb,wc, 
             sela,selb, stato );
             
  end schem;
                 

        
             


